%% Skript zur Aufgabe 2 - Blatt 1
clear
close all
    
%% Parameter fuer die beiden Verfahren
tol = 1e-10;
maxit = 100;
% verschiedene Werte fuer n
nn = [5, 10, 20, 50, 100, 150, 200];

for j = 1 : length(nn)
    %% Matrix initialisieren
    n = nn(j);
    Q = orth(rand(n));
    A = Q * diag(1 : n) * Q';
    
    %% Startvektor
    x0 = ones(n, 1);
    
    %% Potenzverfahren
    [ x_P, lambda_P ] = Potenzverfahren( A, x0, tol, maxit );
    
    %% inverse Iteration
    [ x_inv, lambda_inv ] = inverse_Iteration( A, x0, tol, maxit );
    
    %% Fehler
    err_Pot = abs(lambda_P - n) / (n); % Fehler des Potenzverfahrens
    err_inv = abs(lambda_inv - 1); % Fehler der inversen Iteration
    
    %% Plot
    figure(j)
    % logarithmisch skalierter Plot des Fehlers des Potenzverfahrens
    semilogy(err_Pot, 'r')
    % beide Graphen in einem Plot
    hold on
    % logarithmisch skalierter plot des Fehlers der inversen Iteration
    semilogy(err_inv, 'b')
    % Legende
    legend('Potenzverfahren', 'inverse Iteration') % Legende
    % x-Achsenbeschriftung
    xlabel('Iteration')
    % y-Achsenbeschriftung
    y = ylabel(['relativer Fehler ', ...
        '$\displaystyle\frac{|\lambda - \lambda_j|}{|\lambda|}$']);
    set(y,'Interpreter','Latex');
    % Titel
    title(sprintf('Fehler der Beiden Verfahren fuer n = %d', n));
end